datablock AudioProfile(DARFireSound)
{
   filename    = "Add-Ons/Weapon_Blockombat/Sounds/DARFire.wav";
   description = GunShotRange3d;
   preload = true;
};
datablock ItemData(DARItem)
{
	shapeFile	= "Add-Ons/Weapon_Blockombat/Models/DAR.dts";
	iconName	= "Add-Ons/Weapon_Blockombat/Icons/icon_DAR";
	image		= DARImage;
	uiName			= "Combat BP";
	maxAmmo			= 30;

	category		= "Weapon";
	className		= "Weapon";
	rotate			= false;
	mass			= 1;
	density			= 1.5;
	elasticity		= 0.2;
	friction		= 0.75;
	emap			= true;
	doColorShift	= true;
	colorShiftColor	= "0.6 0.63 0.6 1.000";
	canDrop			= true;
	canReload		= 1;
};
datablock ShapeBaseImageData(DARImage)
{
	shapeFile	= "Add-Ons/Weapon_Blockombat/Models/DAR.dts";
	item		= DARItem;
	projectile	= M4ComProjectile;
	shellVelocity	= 10.0;
	shellExitDir	= "1 0.0 -0.25";
	minShotTime		= 200;
	eyeOffset		= "0 0 0";

	emap		= true;
	mountPoint	= 0;
	offset		= "0 0 0";
	rotation	= eulerToMatrix( "0 0 0" );
	correctMuzzleVector	= true;
	className			= "WeaponImage";
	ammo				= "";
	projectileType		= Projectile;
	casing				= gunshell2debris;
	shellExitOffset		= "0 0 0";
	shellExitVariance	= 2.0;		
	melee			= false;
	armReady		= true;
	doColorShift	= true;
	colorShiftColor	= DARItem.colorShiftColor;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.2;
	stateTransitionOnTimeout[0]	= "LoadCheckA";

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateTransitionOnNoAmmo[1]		= "Reload";
	stateTransitionOnTimeout[1]		= "weaponLoop";
	stateTimeoutValue[1]			= 0.05;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Fire1";
	stateTimeoutValue[2]            = 0.07;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]					= ATACFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= DARFireSound;

	stateName[3]					= "Delay";
	stateTransitionOnTriggerUp[3]   = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.06;
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= lightSmokeEmitter;
	stateEmitterTime[3]				= 0.03;
	stateEmitterNode[3]				= "muzzleNode";
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]		= 0.01;
	stateTransitionOnTimeout[4]	= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]	= "Ready";
	stateTransitionOnNoAmmo[5]	= "Reload";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]		= 1.3;
	stateScript[6]				= "onReload";
	stateTransitionOnTimeout[6]	= "Wait";
	stateWaitForTimeout[6]		= true;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]		= 0.6;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]	= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]		= 0.01;
	stateTransitionOnTimeout[8]	= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]	= "Smoke";
	stateTransitionOnNoAmmo[9]	= "ReloadSmoke";
	
	stateName[10] 					 = "Smoke";
	stateEmitter[10]				 = lightSmokeEmitter;
	stateEmitterTime[10]			 = 0.3;
	stateEmitterNode[10]			 = "muzzleNode";
	stateTimeoutValue[10]			 = 0.2;
	stateTransitionOnTimeout[10]	 = "Ready";
	stateTransitionOnTriggerDown[10] = "Fire";
	
	stateName[11] 					 = "ReloadSmoke";
	stateEmitter[11]				 = lightSmokeEmitter;
	stateEmitterTime[11]			 = 0.3;
	stateEmitterNode[11]			 = "muzzleNode";
	stateTimeoutValue[11]			 = 0.2;
	stateTransitionOnTimeout[11]	 = "Reload";
	
	stateName[12]					 = "Reloaded";
	stateTimeoutValue[12]			 = 0.01;
	stateScript[12]				 	 = "onReloaded";
	stateTransitionOnTimeout[12] 	 = "Ready";

	stateName[13]                    = "Fire1";
	stateTransitionOnTimeout[13]     = "Fire2";
	stateTimeoutValue[13]            = 0.07;
	stateFire[13]                    = true;
	stateAllowImageChange[13]        = false;
	stateSequence[13]                = "Fire";
	stateScript[13]                  = "onFire";
	stateEjectShell[13]				 = true;
	stateEmitter[13]				 = ATACFlashEmitter;
	stateEmitterTime[13]			 = 0.05;
	stateEmitterNode[13]			 = "muzzleNode";
	stateWaitForTimeout[13]			 = true;
	stateSound[13]					 = DARFireSound;

	stateName[14]                    = "Fire2";
	stateTransitionOnTimeout[14]     = "Delay";
	stateTimeoutValue[14]            = 0.07;
	stateFire[14]                    = true;
	stateAllowImageChange[14]        = false;
	stateSequence[14]                = "Fire";
	stateScript[14]                  = "onFire";
	stateEjectShell[14]				 = true;
	stateEmitter[14]				 = ATACFlashEmitter;
	stateEmitterTime[14]			 = 0.05;
	stateEmitterNode[14]			 = "muzzleNode";
	stateWaitForTimeout[14]			 = true;
	stateSound[14]					 = DARFireSound;

	stateName[15]					 = "weaponLoop";
	stateTransitionOnTriggerDown[15] = "LoadCheckA";
	stateTimeoutValue[15]			 = 0.0;
	stateTransitionOnTimeout[15]	 = "Ready";
	stateAllowImageChange[15]		 = True;
	stateScript[15]					 = "onWeaponLoop";
};
function DARImage::onMount(%this,%obj,%slot)
{
	%obj.heat = 0;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>5.56x45 AR  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["556rounds"]+0 @ "", 4, 2, 3, 4);}
}
function DARImage::onFire(%this,%obj,%slot)
{
	DARFire(%this,%obj,%slot);
	%obj.toolAmmo[%obj.currTool]--;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>5.56x45 AR  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["556rounds"]+0 @ "", 4, 2, 3, 4);}
	if($BKT::Recoil)
	{
		%projectile = "ATACRecoilProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
	}
	MissionCleanup.add(%p);
	return %p;
}
function DARImage::onWeaponLoop(%this,%obj,%slot)
{
	if(%obj.heat > 0)
	{
		%obj.heat -= 2;
	}
	if(%obj.heat < 0){%obj.heat = 0;}
}
function DARFire(%this,%obj,%slot,%val)
{
	%projectile = M4ComProjectile;

	if(vectorLen(%obj.getVelocity()) < 4)
	{
		%spread = 0.0002 + (%obj.heat * 0.00014);
	}
	else
	{
		%spread = 0.0009 + (%obj.heat * 0.00014);
	}

	%obj.maxHeat = 12;
	if(%obj.heat < %obj.maxHeat)
		%obj.heat += 1;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	if($BKT::Flash)
	{
		%projectile = "ATACFlashProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function DARImage::onReload(%this,%obj,%slot)
{
	%obj.client.quantity["556rounds"] += %obj.toolAmmo[%obj.currTool];
	%obj.toolAmmo[%obj.currTool] = 0;%obj.heat = 0;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>5.56x45 AR  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["556rounds"]+0 @ "", 4, 2, 3, 4);}
	if(%obj.client.quantity["556rounds"] >= 3)
	{
		%obj.playThread(2, shiftright);
		%obj.playThread(3, shiftdown);
		serverPlay3D(rifleMagOutSound,%obj.getPosition()); 
	}
}
function DARImage::onReloaded(%this,%obj,%slot)
{
	if(%obj.client.quantity["556rounds"] >= 3)
	{
		if(%obj.client.quantity["556rounds"] > %this.item.maxAmmo)
		{
			%obj.client.quantity["556rounds"] -= %this.item.maxAmmo;
			%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
			%obj.setImageAmmo(%slot,1);
			%obj.playThread(2, leftrecoil);
			%obj.playThread(3, plant);
			serverPlay3D(rifleMagInSound,%obj.getPosition());
			if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>5.56x45 AR  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["556rounds"]+0 @ "", 4, 2, 3, 4);}
		}
		else if(%obj.client.quantity["556rounds"] <= %this.item.maxAmmo)
		{
			%obj.toolAmmo[%obj.currTool] = 3 * mFloor(%obj.client.quantity["556rounds"] / 3);
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["556rounds"] = %obj.client.quantity["556rounds"] - %obj.toolAmmo[%obj.currTool];	
			%obj.playThread(2, leftrecoil);
			%obj.playThread(3, plant);
			serverPlay3D(rifleMagInSound,%obj.getPosition());
			if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>5.56x45 AR  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["556rounds"]+0 @ "", 4, 2, 3, 4);}
			return;
		}
	}
}