datablock AudioProfile(G18FAOFireSound)
{
   filename    = "Add-Ons/Weapon_Blockombat/Sounds/G18FAOFire.wav";
   description = GunShotRange3d;
   preload = true;
};
datablock ProjectileData(G18FAOProjectile)
{
	directDamage		= 14;
	gravityMod			= 0.75;
	muzzleVelocity		= 160;
	brickExplosionForce	= 4;
	impactImpulse		= 100;
	verticalImpulse		= 100;
	lifetime			= 1000;
	fadeDelay			= 750;
	particleEmitter		= "ShortVaporTrailEmitter";

	radiusDamage		= 0;
	damageRadius		= 0;
	projectileShapeName	= "add-ons/weapon_gun/bullet.dts";
	directDamageType	= $DamageType::UniversalHeadshot;
	radiusDamageType	= $DamageType::UniversalHeadshot;
	brickExplosionRadius			= 0;
	brickExplosionImpact			= true;
	brickExplosionMaxVolume			= 3;
	brickExplosionMaxVolumeFloating	= 10;
	explosion			= GBImpact2Explosion;
	sound				= BulletWhizzingSound;
	velInheritFactor	= 0;
	armingDelay			= 10;
	bounceElasticity	= 0.5;
	bounceFriction		= 0.1;
	isBallistic			= true;
	hasLight			= false;
	lightRadius			= 3.0;
	lightColor			= "0 0 0";
};
function G18FAOProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	%damageType = $DamageType::Direct;
	if(%this.DirectDamageType)
	{
		%damageType = %this.DirectDamageType;
	}
	%scale = getWord(%obj.getScale(), 2);
	%directDamage = 5*5;
	%damage = %directDamage;
	%sobj = %obj.sourceObject;
	if(%col.getType() & $TypeMasks::PlayerObjectType)
	{
		%directDamage = 14;
		%colscale = getWord(%col.getScale(),2);
		if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale && $BKT::HS)
		{
			%directDamage = 21;
			%damageType = $DamageType::UniversalHeadshot;
		}
		%col.damage(%obj, %pos, %directDamage, %damageType);
	}
	else
	{
		%col.damage(%obj,%pos,%directDamage,%damageType);
	}
}
datablock ItemData(G18FAOItem)
{
	shapeFile	= "Add-Ons/Weapon_Blockombat/Models/G18FAO.dts";
	iconName	= "Add-Ons/Weapon_Blockombat/Icons/icon_G18FAO";
	image		= G18FAOImage;
	uiName			= "Machine P.";
	maxAmmo			= 33;

	category		= "Weapon";
	className		= "Weapon";
	rotate			= false;
	mass			= 1;
	density			= 1.5;
	elasticity		= 0.2;
	friction		= 0.75;
	emap			= true;
	doColorShift	= true;
	colorShiftColor	= "0.7 0.72 0.7 1.000";
	canDrop			= true;
	canReload		= 1;
};
datablock ShapeBaseImageData(G18FAOImage)
{
	shapeFile	= "Add-Ons/Weapon_Blockombat/Models/G18FAO.dts";
	item		= G18FAOItem;
	projectile	= G18FAOProjectile;
	shellVelocity	= 10.0;
	shellExitDir	= "1.0 0.0 0.5";
	minShotTime		= 40; //WO THATS FAST
	eyeOffset		= "0 0 0";

	emap		= true;
	mountPoint	= 0;
	offset		= "0 0 0";
	rotation	= eulerToMatrix( "0 0 0" );
	correctMuzzleVector	= true;
	className			= "WeaponImage";
	ammo				= "";
	projectileType		= Projectile;
	casing				= gunshell2debris;
	shellExitOffset		= "0 0 0";
	shellExitVariance	= 2.0;		
	melee			= false;
	armReady		= true;
	doColorShift	= true;
	colorShiftColor	= G18FAOItem.colorShiftColor;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.0;
	stateTransitionOnTimeout[0]	= "LoadCheckA";

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateTransitionOnNoAmmo[1]		= "Reload";
	stateTransitionOnTimeout[1]		= "weaponLoop";
	stateTimeoutValue[1]			= 0.05;

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2]	= "Smoke";
	stateTimeoutValue[2]		= 0.01;
	stateSequence[2]			= "Fire";
	stateFire[2]				= true;
	stateAllowImageChange[2]	= false;
	stateSequence[2]			= "SlideBack";
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]				= ATACFlashEmitter;
	stateEmitterTime[2]			= 0.01;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= G18FAOFireSound;

	stateName[3]				= "Smoke";
	stateEjectShell[3]			= true;
	stateEmitter[3]				= lightsmokeEmitter;
	stateEmitterTime[3]			= 0.125;
	stateEmitterNode[3]			= "muzzleNode";
	stateAllowImageChange[3]	= false;
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";
	stateTimeoutValue[3]		= 0.0;

	stateName[4] 				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateAllowImageChange[4]	= false;
	stateTimeoutValue[4]		= 0.05;
	stateTransitionOnTimeout[4]	= "LoadCheckB";

	stateName[5]				= "LoadCheckB";
	stateAllowImageChange[5]	= false;
	stateTransitionOnAmmo[5]	= "Ready";
	stateTransitionOnNoAmmo[5]	= "ReloadWait";

	stateName[6]				= "Reload";
	stateAllowImageChange[6]	= true;
	stateTimeoutValue[6]		= 1.1;
	stateScript[6]				= "OnReload";
	stateTransitionOnTimeout[6]	= "Reloaded";
	stateWaitForTimeout[6]		= true;
	
	stateName[7]				= "Reloaded";
	stateAllowImageChange[7]	= false;
	stateTimeoutValue[7]		= 0.2;
	stateScript[7]				= "onReloaded";
	stateTransitionOnTimeout[7]	= "FireLoadCheckB";

	stateName[8]					= "weaponLoop";
	stateTransitionOnTriggerDown[8]	= "LoadCheckA";
	stateTimeoutValue[8]			= 0.0;
	stateTransitionOnTimeout[8]		= "Ready";
	stateAllowImageChange[8]		= true;
	stateScript[8]					= "onWeaponLoop";

	stateName[9]				= "ReloadWait";
	stateAllowImageChange[9]	= false;
	stateTimeoutValue[9]		= 0.15;
	stateTransitionOnTimeout[9]	= "Reload";

	stateName[10]					= "TriggerCheck";

	stateName[11]					= "slideforward";
	stateSequence[11]				= "SlideForward";
	stateAllowImageChange[11]		= false;
	stateSound[11]					= slideForwardSound;
	stateTimeoutValue[12]			= 0.0025;
	stateTransitionOnTimeout[11]	= "Ready";

	stateName[12] 					= "FireLoadCheckA";
	stateScript[12]					= "onLoadCheck";
	stateAllowImageChange[12]		= false;
	stateTimeoutValue[12]			= 0.001;
	stateTransitionOnTimeout[12]	= "FireLoadCheckB";

	stateName[13]				= "FireLoadCheckB";
	stateAllowImageChange[13]	= false;
	stateTransitionOnAmmo[13]	= "slideforward";
	stateTransitionOnNoAmmo[13]	= "ReloadWait";
};
function G18FAOImage::onMount(%this,%obj,%slot)
{
	%obj.heat = 0;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>9mm Para. MP  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["9mmRounds"]+0 @ "", 4, 2, 3, 4);}
}
function G18FAOImage::onFire(%this,%obj,%slot)
{
	G18FAOFire(%this,%obj,%slot);
	%obj.toolAmmo[%obj.currTool]--;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>9mm Para. MP  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["9mmRounds"]+0 @ "", 4, 2, 3, 4);}
	if($BKT::Recoil)
	{
		%projectile = "ATACRecoilProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
	}
	MissionCleanup.add(%p);
	return %p;
}
function G18FAOImage::onWeaponLoop(%this,%obj,%slot)
{
	if(%obj.heat > 0)
	{
		%obj.heat -= 3;
	}
	if(%obj.heat < 0){%obj.heat = 0;}
}
function G18FAOFire(%this,%obj,%slot,%val)
{
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-1.0")));
	%projectile = G18FAOProjectile;
	if(%obj.heat >= 13)
	{
		%obj.playThread(3, rotccw);
	}
	else if(%obj.heat >= 4)
	{
		%obj.playThread(3, plant);
	}

	%spread = 0.0012 + (%obj.heat * 0.00016);

	%obj.maxHeat = 14;
	if(%obj.heat < %obj.maxHeat)
		%obj.heat += 2;
	%shellcount = 1;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	if($BKT::Flash)
	{
		%projectile = "ATACFlashProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function G18FAOImage::onReload(%this,%obj,%slot)
{
	%obj.client.quantity["9mmRounds"] += %obj.toolAmmo[%obj.currTool];
	%obj.toolAmmo[%obj.currTool] = 0;%obj.heat = 0;%obj.heat = 0;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>9mm Para. MP  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["9mmRounds"]+0 @ "", 4, 2, 3, 4);}
	if(%obj.client.quantity["9mmRounds"] >= 1)
	{
		%obj.playThread(2, activate);
		%obj.playThread(3, plant);
		serverPlay3D(pistolmagOutSound,%obj.getPosition()); 
	}
}
function G18FAOImage::onReloaded(%this,%obj,%slot)
{
	if(%obj.client.quantity["9mmRounds"] >= 1)
	{
		if(%obj.client.quantity["9mmRounds"] > %this.item.maxAmmo)
		{
			%obj.client.quantity["9mmRounds"] -= %this.item.maxAmmo;
			%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
			%obj.setImageAmmo(%slot,1);
			%obj.playThread(2, shiftleft);
			%obj.playThread(3, leftrecoil);
			%obj.playThread(4, shiftdown);
			serverPlay3D(pistolMagInSound,%obj.getPosition());
			if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>9mm Para. MP  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["9mmRounds"]+0 @ "", 4, 2, 3, 4);}
		}
		else if(%obj.client.quantity["9mmRounds"] <= %this.item.maxAmmo)
		{
			%obj.toolAmmo[%obj.currTool] = %obj.client.quantity["9mmRounds"];
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["9mmRounds"] = 0;	
			%obj.playThread(2, shiftleft);
			%obj.playThread(3, leftrecoil);
			%obj.playThread(4, shiftdown);
			serverPlay3D(pistolMagInSound,%obj.getPosition());
			if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>9mm Para. MP  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["9mmRounds"]+0 @ "", 4, 2, 3, 4);}
			return;
		}
	}
}