datablock AudioProfile(FSPAS12FireSound)
{
   filename    = "Add-Ons/Weapon_Blockombat/Sounds/FSPAS12Fire.wav";
   description = GunShotRange3d;
   preload = true;
};
datablock ItemData(FSPAS12Item)
{
	shapeFile	= "Add-Ons/Weapon_Blockombat/Models/FSPAS12.dts";
	iconName	= "Add-Ons/Weapon_Blockombat/Icons/icon_FSPAS12";
	image		= FSPAS12Image;
	uiName			= "Enforcer SG";
	maxAmmo			= 8;

	category		= "Weapon";
	className		= "Weapon";
	rotate			= false;
	mass			= 1;
	density			= 1.5;
	elasticity		= 0.2;
	friction		= 0.75;
	emap			= true;
	doColorShift	= true;
	colorShiftColor	= "0.3 0.3 0.32 1.000";
	canDrop			= true;
	canReload		= 1;
};
datablock ShapeBaseImageData(FSPAS12Image)
{
	shapeFile	= "Add-Ons/Weapon_Blockombat/Models/FSPAS12.dts";
	item		= FSPAS12Item;
	projectile	= Moss500Projectile;
	shellVelocity	= 6.0;
	shellExitDir	= "1.0 0.0 0.0";
	minShotTime		= 900;
	eyeOffset		= "0 0 0";

	emap		= true;
	mountPoint	= 0;
	offset		= "0 0 0";
	rotation	= eulerToMatrix( "0 0 0" );
	correctMuzzleVector	= true;
	className			= "WeaponImage";
	ammo				= "";
	projectileType		= Projectile;
	casing				= bktshotgunshelldebris;
	shellExitOffset		= "0 0 0";
	shellExitVariance	= 6.0;		
	melee			= false;
	armReady		= true;
	doColorShift	= true;
	colorShiftColor	= FSPAS12Item.colorShiftColor;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.3;
	stateTransitionOnTimeout[0]	= "LoadCheckA";

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateTransitionOnNoAmmo[1]		= "Reload";

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2]	= "Smoke";
	stateTimeoutValue[2]		= 0.1;
	stateFire[2]				= true;
	stateAllowImageChange[2]	= false;
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]				= ATACFlashEmitter;
	stateEmitterTime[2]			= 0.0725;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= FSPAS12FireSound;

	stateName[3]				= "Smoke";
	stateEmitter[3]				= lightsmokeEmitter;
	stateEmitterTime[3]			= 0.1;
	stateEmitterNode[3]			= "muzzleNode";
	stateAllowImageChange[3]	= false;
	stateTransitionOnTimeout[3]	= "PumpOut";
	stateTimeoutValue[3]		= 0.375;

	stateName[4] 				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateAllowImageChange[4]	= false;
	stateTimeoutValue[4]		= 0.1;
	stateTransitionOnTimeout[4]	= "LoadCheckB";

	stateName[5]				= "LoadCheckB";
	stateAllowImageChange[5]	= false;
	stateTransitionOnAmmo[5]	= "Ready";
	stateTransitionOnNoAmmo[5]	= "Reload";

	stateName[6]					= "Reload";
	stateAllowImageChange[6]		= true;
	stateTimeoutValue[6]			= 0.55;
	stateScript[6]					= "OnReload";
	stateTransitionOnTimeout[6]		= "Reload";
	stateWaitForTimeout[6]			= false;
	stateTransitionOnTriggerDown[6]	= "FireLoadCheckA";

	stateName[8] 				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateAllowImageChange[8]	= false;
	stateTimeoutValue[8]		= 0.1;
	stateTransitionOnTimeout[8]	= "TriggerCheck";

	stateName[9]				= "FireLoadCheckB";
	stateAllowImageChange[9]	= false;
	stateTransitionOnAmmo[9]	= "PumpIn";
	stateTransitionOnNoAmmo[9]	= "Reload";

	stateName[7]				= "PumpIn";
	stateTransitionOnTimeout[7]	= "Ready";
	stateTimeoutValue[7]		= 0.2;
	stateScript[7]				= "onPump";

	stateName[10]				= "PumpOut";
	stateEjectShell[10]			= true;
	stateSequence[10]			= "reload";
	stateAllowImageChange[10]	= false;
	stateTimeoutValue[10]		= 0.1;
	stateTransitionOnTimeout[10]= "FireLoadCheckA";
	stateScript[10]				= "onPump";
	
	stateName[11]					= "TriggerCheck";
	stateTransitionOnTriggerUp[11]	= "FireLoadCheckB";	
};
function FSPAS12Image::onMount(%this,%obj,%slot)
{
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>12 Gauge SG  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["shotgunrounds"]+0 @ "", 4, 2, 3, 4);}
}
function FSPAS12ADSImage::onMount(%this,%obj,%slot)
{
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>12 Gauge SG  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["shotgunrounds"]+0 @ "", 4, 2, 3, 4);}
	if($BKT::CH)
	{
		crossHair.setBitmap("add-ons/weapon_blockombat/empty.png");
	}
}
function FSPAS12Image::onPump(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	serverPlay3D(pump2Sound,%obj.getPosition());
}
function FSPAS12Image::onFire(%this,%obj,%slot)
{
	FSPAS12Fire(%this,%obj,%slot);
	%obj.toolAmmo[%obj.currTool]--;

	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>12 Gauge SG  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["shotgunrounds"]+0 @ "", 4, 2, 3, 4);}
	if($BKT::Recoil)
	{
		%projectile = "ATACRecoilProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
	}
	MissionCleanup.add(%p);
	return %p;
}
function FSPAS12Fire(%this,%obj,%slot,%val)
{
	%projectile = "muzzleBlastProjectile";
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);

	%obj.playThread(2, shiftUp);
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-3.0")));
	%projectile = Moss500Projectile;
	%spread = 0.00275;
	%shellcount = 7;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	if($BKT::Flash)
	{
		%projectile = "ATACFlashProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function FSPAS12Image::onReload(%this,%obj,%slot)
{
	if(%obj.client.quantity["shotgunrounds"] >= 1 && %obj.toolAmmo[%obj.currTool] != %this.item.maxAmmo)
	{
		%obj.playThread(2, shiftRight);
		%obj.playThread(3, leftRecoil);
		%obj.toolAmmo[%obj.currTool]++;
		%obj.client.quantity["shotgunRounds"] -= 1;
		serverPlay3D(shellInSound,%obj.getPosition());
	}
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>12 Gauge SG  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["shotgunrounds"]+0 @ "", 4, 2, 3, 4);}
}