// (Originally) just a general easter egg; the "cock inspector"
datablock AudioProfile(Walther2000FireSound)
{
   filename    = "Add-Ons/Weapon_Blockombat/Sounds/Walther2000Fire.wav";
   description = LongRange3d;
   preload = true;
};
datablock ProjectileData(Walther2000Projectile)
{
	directDamage		= 49;
	gravityMod			= 1;
	muzzleVelocity		= 1;
	brickExplosionForce	= 15;
	impactImpulse		= 1000;
	verticalImpulse		= 500;
	lifetime			= 10000;
	fadeDelay			= 8000;

	radiusDamage		= 0;
	damageRadius		= 0;
	projectileShapeName	= "base/data/shapes/empty.dts";
	directDamageType	= $DamageType::UniversalHeadshot;
	radiusDamageType	= $DamageType::UniversalHeadshot;
	brickExplosionRadius			= 0;
	brickExplosionImpact			= true;
	brickExplosionMaxVolume			= 3;
	brickExplosionMaxVolumeFloating	= 10;
	explosion			= shotgunExplosion;
	sound				= BulletWhizzingSound;
	velInheritFactor	= 0;
	armingDelay			= 10;
	bounceElasticity	= 0.5;
	bounceFriction		= 0.1;
	isBallistic			= true;
	hasLight			= false;
	lightRadius			= 3.0;
	lightColor			= "0 0 0";
};
function Walther2000Projectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	%damageType = $DamageType::Direct;
	if(%this.DirectDamageType)
	{
		%damageType = %this.DirectDamageType;
	}
	%scale = getWord(%obj.getScale(), 2);
	%directDamage = 65*5;
	%damage = %directDamage;
	%sobj = %obj.sourceObject;
	if(%col.getType() & $TypeMasks::PlayerObjectType)
	{
		%directDamage = 65;
		%colscale = getWord(%col.getScale(),2);
		if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
		{
			%directDamage = 650;
			%damageType = $DamageType::UniversalHeadshot;
		}
		%col.damage(%obj, %pos, %directDamage, %damageType);
	}
	else
	{
		%col.damage(%obj,%pos,%directDamage,%damageType);
	}
}
package Walther2000psm
{
	function Projectile::onAdd(%obj,%a,%b)
	{
		if(%obj.dataBlock.getID() == Walther2000Projectile.getID())
		{
			%obj.initialvelocity=vectorscale(vectorNormalize(%obj.initialvelocity),500);
		}
		Parent::onAdd(%obj,%a,%b);
	}
};
activatePackage(Walther2000psm);
datablock ItemData(Walther2000Item)
{
	shapeFile	= "Add-Ons/Weapon_Blockombat/Models/Walther2000.dts";
	iconName	= "Add-Ons/Weapon_Blockombat/Icons/icon_Walther2000";
	image		= Walther2000Image;
	uiName			= "Auto Sniper";
	maxAmmo			= 3;

	category		= "Weapon";
	className		= "Weapon";
	rotate			= false;
	mass			= 1;
	density			= 1.5;
	elasticity		= 0.2;
	friction		= 0.75;
	emap			= true;
	doColorShift	= true;
	colorShiftColor	= "0.45 0.45 0.45 1.000";
	canDrop			= true;
	canReload		= 1;
};
datablock ShapeBaseImageData(Walther2000Image)
{
	shapeFile	= "Add-Ons/Weapon_Blockombat/Models/Walther2000.dts";
	item		= Walther2000Item;
	projectile	= Walther2000Projectile;
	shellVelocity	= 8.0;
	shellExitDir	= "1.0 -0.0 0.5";
	minShotTime		= 250;
	eyeOffset		= "0 0 0";

	emap		= true;
	mountPoint	= 0;
	offset		= "0 0 0";
	rotation	= eulerToMatrix( "0 0 0" );
	correctMuzzleVector	= true;
	className			= "WeaponImage";
	ammo				= "";
	projectileType		= Projectile;
	casing				= gunshell2debris;
	shellExitOffset		= "0 0 0";
	shellExitVariance	= 6.0;		
	melee			= false;
	armReady		= true;
	doColorShift	= true;
	colorShiftColor	= Walther2000Item.colorShiftColor;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.4;
	stateTransitionOnTimeout[0]	= "LoadCheckA";

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateTransitionOnNoAmmo[1]		= "Reload";
	stateTimeoutValue[1]			= 0.1;

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2]	= "Smoke";
	stateTimeoutValue[2]		= 0.1;
	stateSequence[2]			= "Fire";
	stateFire[2]				= true;
	stateAllowImageChange[2]	= false;
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]				= ATACFlashEmitter;
	stateEmitterTime[2]			= 0.1;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= Walther2000FireSound;

	stateName[3]				= "Smoke";
	stateEjectShell[3]			= true;
	stateSequence[3]			= "reload1";
	stateEmitter[3]				= lightsmokeEmitter;
	stateEmitterTime[3]			= 0.2;
	stateEmitterNode[3]			= "muzzleNode";
	stateAllowImageChange[3]	= false;
	stateTransitionOnTimeout[3]	= "TriggerCheck";
	stateTimeoutValue[3]		= 0.05;

	stateName[4] 				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateAllowImageChange[4]	= false;
	stateTimeoutValue[4]		= 0.1;
	stateTransitionOnTimeout[4]	= "LoadCheckB";

	stateName[5]				= "LoadCheckB";
	stateAllowImageChange[5]	= false;
	stateTransitionOnAmmo[5]	= "Ready";
	stateTransitionOnNoAmmo[5]	= "ReloadWait";

	stateName[6]				= "Reload";
	stateAllowImageChange[6]	= true;
	stateTimeoutValue[6]		= 1.5;
	stateScript[6]				= "OnReload";
	stateTransitionOnTimeout[6]	= "Reloaded";
	stateWaitForTimeout[6]		= true;
	
	stateName[7]				= "Reloaded";
	stateAllowImageChange[7]	= false;
	stateTimeoutValue[7]		= 0.4;
	stateScript[7]				= "onReloaded";
	stateTransitionOnTimeout[7]	= "LoadCheckA";

	stateName[8]				= "ReloadWait";
	stateAllowImageChange[8]	= false;
	stateTimeoutValue[8]		= 0.4;
	stateTransitionOnTimeout[8]	= "Reload";

	stateName[9]					= "TriggerCheck";
	stateTransitionOnTriggerUp[9]	= "LoadCheckA";
};
function Walther2000Image::onMount(%this,%obj,%slot)
{
	%obj.heat = 0;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.338 Sniper  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["338rounds"]+0 @ "", 4, 2, 3, 4);}
}
function Walther2000Image::onFire(%this,%obj,%slot)
{
	Walther2000Fire(%this,%obj,%slot);
	%obj.toolAmmo[%obj.currTool]--;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.338 Sniper  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["338rounds"]+0 @ "", 4, 2, 3, 4);}
	if($BKT::Recoil)
	{
		%projectile = "ATACRecoilProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
	}
	MissionCleanup.add(%p);
	return %p;
}
function Walther2000Fire(%this,%obj,%slot,%val)
{
	%projectile = "muzzleBlastProjectile";
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);

	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-2.5")));
	%projectile = Walther2000Projectile;
	if(vectorLen(%obj.getVelocity()) < 4 && (getSimTime() - %obj.lastShotTime) > 750)
	{
		%spread = 0.00025;
	}
	else
	{
		%spread = 0.005;
		%obj.playThread(3, plant);
	}
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	if($BKT::Flash)
	{
		%projectile = "ATACFlashProjectile";	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function Walther2000Image::onReload(%this,%obj,%slot)
{
	%obj.client.quantity["338rounds"] += %obj.toolAmmo[%obj.currTool];
	%obj.toolAmmo[%obj.currTool] = 0;%obj.heat = 0;
	if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.338 Sniper  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["338rounds"]+0 @ "", 4, 2, 3, 4);}
	if(%obj.client.quantity["338rounds"] >= 1)
	{
		%obj.playThread(2, shiftRight);
		serverPlay3D(riflemagOutSound,%obj.getPosition()); 
	}
}
function Walther2000Image::onReloaded(%this,%obj,%slot)
{
	if(%obj.client.quantity["338rounds"] >= 1)
	{
		if(%obj.client.quantity["338rounds"] > %this.item.maxAmmo)
		{
			%obj.client.quantity["338rounds"] -= %this.item.maxAmmo;
			%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
			%obj.setImageAmmo(%slot,1);
			%obj.playThread(2, plant);
			serverPlay3D(riflemagInSound,%obj.getPosition());
			if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.338 Sniper  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["338rounds"]+0 @ "", 4, 2, 3, 4);}
		}
		else if(%obj.client.quantity["338rounds"] <= %this.item.maxAmmo)
		{
			%obj.toolAmmo[%obj.currTool] = %obj.client.quantity["338rounds"];
			%obj.setImageAmmo(%slot,1);
			%obj.client.quantity["338rounds"] = 0;	
			%obj.playThread(2, plant);
			serverPlay3D(riflemagInSound,%obj.getPosition());
			if($BKT::DH){commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:FF0000>.338 Sniper  <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool]+0 @ " / " @ %obj.client.quantity["338rounds"]+0 @ "", 4, 2, 3, 4);}
			return;
		}
	}
}